All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros
static.hpp File Reference
`#include <uhd/config.hpp>`

Go to the source code of this file.

## Classes

struct | _uhd_static_fixture
| Helper for static block, constructor calls function. More...

## Macros

#define | UHD_SINGLETON_FCN(_t, _x) static _t &_x(){static _t _x; return _x;}
#define | UHD_STATIC_BLOCK(_x)

## Macro Definition Documentation

#define UHD_SINGLETON_FCN | ( |  | _t,
|  |  | _x
| ) |  | static _t &_x(){static _t _x; return _x;}

Defines a function that implements the "construct on first use" idiom

Parameters

  _t | the type definition for the instance
  _x | the name of the defined function

Returns
  a reference to the lazy instance

#define UHD_STATIC_BLOCK | ( |  | _x | ) |

Value:
void _x(void); \
static _uhd_static_fixture _x##_fixture(&_x, #_x); \
void _x(void)

Defines a static code block that will be called before main() The static block will catch and print exceptions to std error.

Parameters

  _x | the unique name of the fixture (unique per source)